#import "MyOpenGLView.h"
#import <OpenGL/gl.h>
#import <glut/glut.h>

@implementation MyOpenGLView

- (void) awakeFromNib {
  mSetupDone = NO;
}


- (void) drawRect:(NSRect)rect {
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
		
	if ( ! mSetupDone) {
		mSetupDone = YES;
		[self setupGL];
	}

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);   

	glTranslatef(-1.5f,0.0f,-6.0f);

	glColor3f(.2, .4, 0.);
	glBegin(GL_QUADS);
	glVertex3f(-1.0f, 1.0f, 0.0f); // Top Left
	glVertex3f( 1.0f, 1.0f, 0.0f); // Top Right
	glVertex3f( 1.0f,-1.0f, 0.0f); // Bottom Right
	glVertex3f(-1.0f,-1.0f, 0.0f); // Bottom Lef
	glEnd();

	glColor3f(1., 0., 0.);
	glBegin(GL_TRIANGLES); 
	glVertex3f( 0.0f, 1.0f, 0.0f); // Top
	glVertex3f(-1.0f,-1.0f, 0.0f); // Bottom Left
	glVertex3f( 1.0f,-1.0f, 0.0f); // Bottom Right
	glEnd();

  // i'm not using doublebuffering, so i should not need flushBuffer:
  //if ([self inLiveResize])
      glFlush();
  //else
  //    [[self openGLContext] flushBuffer];
}

- (void) reshape {
  NSRect rect = [self bounds];
  GLdouble aspect;

  glViewport(0, 0, (GLsizei) rect.size.width, (GLsizei) rect.size.height);

  glMatrixMode(GL_PROJECTION); 
  glLoadIdentity();

  aspect = rect.size.width / rect.size.height;
  gluPerspective(45.0f, aspect, 0.1f, 100.0f);
}


- (void) setupGL {       
  // reshape: has already been called by os x and the modelview matrix
  // has already been selected in drawRect
  glShadeModel(GL_SMOOTH);
  glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
  glClearDepth(1.0f);

  // do i need this? I already setup depth buffer within IB
  //glEnable(GL_DEPTH_TEST);
  //glDepthFunc(GL_LEQUAL);
        
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
}

@end
